<script lang="ts">
	import { CardStatus, CardVariant } from '$lib/types/card';

	export let variant: CardVariant = CardVariant.STANDARD;
	export let status: CardStatus = CardStatus.STANDARD;

	let classes = 'wrapper';
	classes += ' variant-' + variant;
	classes += ' status-' + status;
</script>

<div class={classes}>
	<div class="bg" />
	<div class="inner">
		<slot />
	</div>
</div>

<style lang="scss">
	.wrapper {
		position: relative;
	}

	.wrapper :global(.icon) {
		width: 2em;
	}

	.wrapper :global(.title) {
		font-size: 1em;
		margin-top: 1rem;
		margin-bottom: 0.5rem;
	}

	.wrapper :global(p) {
		margin: 0;
	}

	.wrapper .inner {
		position: relative;
		padding: 1em;

		@media (min-width: 760px) {
			padding: 1.5em;
		}
	}

	.wrapper .bg {
		position: absolute;
		top: 0;
		right: 0;
		left: 0;
		bottom: 0;
		width: 100%;
		height: 100%;
		border-radius: 4px;
		border: 2px solid var(--color-card-border);
		background-color: var(--color-card-bg);
		transition: 250ms color, 250ms background-color, 250ms border-color;
		-webkit-backdrop-filter: blur(1em);
		backdrop-filter: blur(1em);
	}

	// Variants
	.wrapper.variant-glass .bg {
		border-color: var(--color-card-glass-border);
		background-color: var(--color-card-glass-bg);
	}

	// Status
	.wrapper.status-active .bg {
		border-color: var(--color-primary-500);
	}
</style>
